{
  services.prometheus = {
    enable = true;
    exporters = {
      node = {
        enable = true;
        enabledCollectors = [ "systemd" ];
      };
      systemd = {
        enable = true;
      };
      process = {
        enable = true;
        #settings.process_names = [];
      };
    };
    scrapeConfigs = [{
      job_name = "nodes";
      static_configs = [{
        targets = [
          "127.0.0.1:9100" # node exporter
          "127.0.0.1:9558" # systemd exporter
          "127.0.0.1:9256" # process exporter
        ];
      }];
    }];
  };
  services.grafana = {
    enable = true;
    provision = {
      enable = true;
      datasources.settings.datasources = [{
        name = "Prometheus";
        type = "prometheus";
        access = "proxy";
        url = "http://127.0.0.1:9090";
      }];
    };
    settings = {
      server = {
         http_port = 30000;
         #domain = "meow-corp.xyz";
         domain = "localhost";
      };
    };
  };
}
