let
  prometheus-yaml = builtins.toFile "prometheus.yml" ''
    "scrape_configs": [
      {
        "job_name": "nodes",
        "static_configs": [
          {
            "labels": {},
            "targets": [
              "127.0.0.1:9100",
              "127.0.0.1:9558",
              "127.0.0.1:9256"
            ]
          }
        ]
      }
    ]
  '';
in
{
  services.prometheus = {
    enable = false;
    exporters = {
      node = {
        enable = true;
        enabledCollectors = [ "systemd" ];
      };
      systemd = {
        enable = true;
      };
      process = {
        enable = true;
        #settings.process_names = [];
      };
    };
  };
  services.victoriametrics = {
    enable = true;
    extraOptions = [ "-promscrape.config=${prometheus-yaml}" ];
  };
  services.grafana = {
    enable = true;
    provision = {
      enable = true;
      datasources.settings.datasources = [
        {
          name = "Victoriametrics2";
          type = "prometheus";
          access = "proxy";
          url = "http://127.0.0.1:8428";
        }
      ];
    };
    settings = {
      server = {
         http_port = 30000;
         #domain = "meow-corp.xyz";
         domain = "localhost";
      };
    };
  };
}
